; GUI #
include win64a.inc
.code
capt        db "Hello!",0
msg         db "Customized message box",0
ButtonText  db "OK",0
bclass      db "Button",0
hlpfile     db "imagedit.hlp",0
pOldProc    dq ?
HelpBtnID   dq ?
message	    dq ?
caption	    dq ?
button	    dq ?
 
WinMain proc
LOCAL ThreadID:QWORD
LOCAL hWnd:QWORD
LOCAL hThread:QWORD
LOCAL hClick:QWORD
 
	mov edx,offset msg
	mov message,rdx
        mov r8d,offset capt
	mov caption,r8
	mov r9d,offset ButtonText
	mov button,r9
        invoke CreateThread,0,\   	  ;   
                            0,\    	  ;    
                            &ThreadProc1,\; 
                            &caption,\    ;  
                            0,\           ;    
                            &ThreadID     ;  
        mov hThread,rax
 
        invoke GetCurrentProcess
        invoke WaitForInputIdle,rax,INFINITE
        invoke EnumWindows,&EnumWndProc,&ThreadID
        invoke FindWindowEx,hWnd,0,&bclass,0
        mov hClick,rax

        invoke FindWindowEx,hWnd,eax,&bclass,0
        invoke GetDlgCtrlID,rax
        mov HelpBtnID,rax

        invoke SetWindowText,hClick,&ButtonText
        invoke SetWindowLongPtr,hWnd,GWL_WNDPROC,&MsgboxProc
        mov pOldProc,rax
 
        invoke WaitForSingleObject,hThread,INFINITE
        invoke CloseHandle,hThread
	invoke RtlExitUserProcess,NULL
WinMain endp
 
ThreadProc1 PROC pParams:QWORD
	mov eax,ecx;ecx=pParams
        invoke MessageBox,QWORD PTR [rax-16],QWORD PTR [rax-8],QWORD PTR [rax],MB_HELP
    	leave
        retn
ThreadProc1 ENDP
 
EnumWndProc PROC hWnd:QWORD,lParam:QWORD
LOCAL pid:QWORD
 
	mov hWnd,rcx
	mov lParam,rdx
 
        invoke GetWindowThreadProcessId,,&pid
        mov rdx,lParam
        cmp eax,[rdx]
        mov eax,TRUE
        jne @f
        mov rax,hWnd
        mov [rdx-8],rax  ; get the handle of the window
        xor eax,eax      ; displaying the message box
@@:     leave
        retn
EnumWndProc ENDP
 
MsgboxProc PROC hWnd:HWND,uMsg:QWORD,wParam:WPARAM,lParam:LPARAM
	mov hWnd,rcx
	mov uMsg,rdx
	mov wParam,r8
	mov lParam,r9
 
        cmp edx,WM_COMMAND
    	jne @f
 
        mov rax,r8;wParam
        mov edx,eax
        shr edx,16
        ;cmp dx,BN_CLICKED=0
        jne @f
 
        mov rcx,HelpBtnID    
        cmp ax,cx
    	jne @f
	mov r8d,offset hlpfile
	invoke ShellExecute,0,0,,0,0,1
@@:	invoke CallWindowProc,pOldProc,hWnd,uMsg,wParam,lParam
	leave
        retn
MsgboxProc    ENDP
end